#ifndef DNSSPOOF_H
#include <pcap.h>
#include "config.h"
#define DNSSPOOF_H
#include <libnet.h>

struct dnsspoof_opts
{
    libnet_ptag_t rr;
    libnet_ptag_t query;
    libnet_ptag_t dns;
    libnet_ptag_t udp;
    libnet_ptag_t ip;
    libnet_ptag_t eth;

    libnet_t *ctx;

    u_int8_t *domain;
    libnet_addr_t fakeip;
};

typedef struct dnsspoof_opts dnsspoof_opts_t;


/******************/
/* Send functions */
/******************/
int 
send_fake_rr(const u_char *packet, size_t sz, 
	     struct libnet_ethernet_hdr *eth,
	     struct libnet_ipv4_hdr *ipv4, 
	     struct libnet_udp_hdr *udp, 
	     struct libnet_dnsv4_hdr *dns, 
	     u_char *query, 
	     dnsspoof_opts_t *opts);

/**********************/
/* Callback functions */
/**********************/
/* Send packets to the host who made the request (hope the first will be received before
 * the answser of the legitimate server) */
void callback_dnsspoof(u_char *args, const struct pcap_pkthdr* pkthdr, const u_char *packet);


/******************/
/* Grab functions */
/******************/
/* Grab dns queries on "device" from "hostsrc" and run the callback function (spoofing) for "destination" IP
 * If device == NULL, then use pcap_lookupdev
 * if srchost == NULL, then grab EVERY UDP DNS PAQUETS (promisc needed)
 */
int grab_dns_queries(int injmode, char *device, char *device_out, char *srchost, char *fakeip, char *domain, int eth_mode);

#endif
